#!/bin/sh
# -----------------------------------------------------------------------------
# main_netstat_httpd.cgi - web interface parameters  fli4l 2.1.10   version 0.1
#
# Erstell:     		07.07.2005  
# Letzte Aenderung:   	07.07.2005  
#
# Urheberrecht (c) 2005 gurkenheinz@gmx 
# -----------------------------------------------------------------------------

SEC_REALM='netstat_httpd'
SEC_ACTION='view'
. ./sec-lib.cgi


RTIME=10


# HTML-Header
echo "Content-Type: text/html; charset=iso-8859-1"
echo "Cache-control: no-store" # HTTP/1.1 (or no-cache?)
echo "Pragma: no-cache"        # HTTP/1.0
echo "Expires: `date -Ru`"     # Expires now!
echo
echo "<html><head>"
echo "<LINK REL=STYLESHEET TYPE=\"text/css\" HREF=\"main.css\">"
echo "<title>opt_info - network</title>"
echo "</head><body bgcolor=\"#FFFFFF\" link=\"#FFFFFF\" vlink=\"#C0C0C0\" alink=\"#FF0000\">"
echo

# Tabelle erstellen
echo "<table border=\"1\" cellpadding=\"0\" cellspacing=\"0\"  width=\"100%\" bgcolor=\"#f0f0f0\" bordercolor=\"#ffffff\">"
echo "<tr bgcolor=\"#000000\">"
echo "<td> <center><b><font face=verdana> <a href=\"main_netstat_httpd.cgi?status\">Status</a> </font></b></center></td>"
echo "<td> <center><b><font face=verdana> <a href=\"main_netstat_httpd.cgi?routen\">Routen</a> </font></b></center></td>"
echo "<td> <center><b><font face=verdana> <a href=\"main_netstat_httpd.cgi?traffic\">Traffic</a> </font></b></center></td>"
echo "<td> <center><b><font face=verdana> <a href=\"main_netstat_httpd.cgi?details\">Details</a> </font></b></center></td>"
echo "</tr></table>"

if [ "$QUERY_STRING" = "" ]
then
#	echo "<center><br><br>Bitte w&auml;hle eine der oberen Kategorien.<br><br></center>"
	echo "<pre>"

echo " # /bin/netstat -s Ausgabe       "  > /tmp/netstat.txt
echo " --------------------------------------------------------------------------------------------------------------- " >> /tmp/netstat.txt
echo ""									 >> /tmp/netstat.txt
/bin/netstat -s >> /tmp/netstat.txt
# aktuelle Eintrge anzeigen
while read text
  do
   echo "<option>$text</option>"
   done < /tmp/netstat.txt
 rm /tmp/netstat.txt
echo "</pre>"
fi

if [ "$QUERY_STRING" = "status" ]
then
echo "<pre>"

/bin/netstat -na > /tmp/netstat.txt
# aktuelle Eintrge anzeigen
while read text
  do
   echo "<option>$text</option>"
   done < /tmp/netstat.txt
 rm /tmp/netstat.txt
echo "</pre>"
fi

if [ "$QUERY_STRING" = "routen" ]
then

echo "<table border=\"1\" cellpadding=\"0\" cellspacing=\"0\" width=\"80%\" bgcolor=\"#f0f0f0\" bordercolor=\"#ffffff\" align=\"center\">"
echo "<tr bgcolor=\"#000000\">"
echo "    <td colspan=\"8\">"
echo "        <div align=\"center\"><font color=\"#ffffff\" face=\"verdana\"><b>Kernel routing table</b></font><div>"
echo "    </td>"
echo "</tr>"
echo "<tr>"
echo "   <td>"
echo "        <center><b><font face=\"verdana\">Destination</font></b></center>"
echo "   </td>"
echo "   <td>"
echo "        <center><b><font face=\"verdana\">Gateway</font></b></center>"
echo "   </td>"
echo "   <td>"
echo "        <center><b><font face=\"verdana\">Genmask</font></b></center>"
echo "   </td>"
echo "   <td>"
echo "        <center><b><font face=\"verdana\">Flags</font></b></center>"
echo "   </td>"
echo "   <td>"
echo "        <center><b><font face=\"verdana\">MSS</font></b></center>"
echo "   </td>"
echo "   <td>"
echo "        <center><b><font face=\"verdana\">Window</font></b></center>"
echo "   </td>"
echo "   <td>"
echo "        <center><b><font face=\"verdana\">Use</font></b></center>"
echo "   </td>"
echo "   <td>"
echo "        <center><b><font face=\"verdana\">Interface</font></b></center>"
echo "   </td>"
echo "</tr>"

/sbin/route -n | grep -v "Kernel" | grep -v "Destination" | while read Destination Gateway Genmask Flags MSS Window Use Iface

do
	echo "<tr>"
	echo "   <td>"
	echo "        <p align=\"center\">$Destination"
	echo "   </td>"
	echo "   <td>"
	echo "        <p align=\"center\">$Gateway"
	echo "   </td>"
	echo "   <td>"
	echo "        <p align=\"center\">$Genmask"
	echo "   </td>"
	echo "   <td>"
	echo "        <p align=\"center\">$Flags"
	echo "   </td>"
	echo "   <td>"
	echo "        <p align=\"center\">$MSS"
	echo "   </td>"
	echo "   <td>"
	echo "        <p align=\"center\">$Window"
	echo "   </td>"
	echo "   <td>"
	echo "        <p align=\"center\">$Use"
	echo "   </td>"
	echo "   <td>"
	echo "        <p align=\"center\">$Iface"
	echo "   </td>"
	echo "</tr>"
done
echo "</table>"
fi

if [ "$QUERY_STRING" = "traffic" ]
then
	echo "<br>"
	echo "<table border=\"1\" cellpadding=\"0\" cellspacing=\"0\"  width=\"80%\" bgcolor=\"#f0f0f0\" bordercolor=\"#ffffff\" align=\"center\">"
	echo "   <tr bgcolor=\"#000000\">"
	echo "      <td colspan=\"9\">"
	echo "         <div align=\"center\"><font color=\"#ffffff\" face=\"verdana\"><b>Netzwerk-Traffic</b></font></div>"
	echo "      </td>"
	echo "   </tr>"
	echo "   <tr>"
	echo "      <td rowspan=\"3\">Interface</td>"
	echo "      <th colspan=\"8\">INCOMING</th>"
    echo "   </tr>"
    echo "   <tr>"
    echo "      <td>bytes</td>"
    echo "      <td>packets</td>"
    echo "      <td>errs</td>"
    echo "      <td>drop</td>"
    echo "      <td>fifo</td>"
    echo "      <td>frame</td>"
    echo "      <td>compr.</td>"
    echo "      <td>multicast</td>"
    echo "   </tr>"
    echo "   <tr>"
    echo "      <th colspan=\"8\">OUTGOING</th>"
    echo "   </tr>"
	cat /proc/net/dev | sed -e '/^Inter-.*$/d' \
	| sed -e '/^ face.*$/d' \
	| sed 's/^\([[:blank:]]*[[:alnum:]]\+:[[:blank:]]*\([[:alnum:]]\+[[:blank:]]\+\)\{8\}\)/\1<\/td><\/tr><tr><td>/g' \
	| sed 's/[[:blank:]]*<\/td><\/tr><tr><td>/<\/td><\/tr><tr><td>/g' \
	| sed 's/[[:blank:]]*:[[:blank:]]*/<\/td><td>/g' \
	| sed 's/^[[:blank:]]*//g' \
	| sed 's/[[:blank:]]*$/<\/td><\/tr>/g' \
	| sed 's/[[:blank:]]\+/<\/td><td>/g' \
	| sed 's/^/<tr><td rowspan="2">/g'
	echo "</table><br>"
	echo "</br>"
fi

if [ "$QUERY_STRING" = "details" ]
then
    echo "<pre>"
    /sbin/ifconfig > /tmp/info_ifconfig.tmp
    cat /tmp/info_ifconfig.tmp
    rm /tmp/info_ifconfig.tmp
    echo "</pre>"
fi

echo ""
echo "<p align=\"right\">"
echo "    <font face=\"verdana\" size=\"-2\">OPT_Netstat_httpd erstellt von <a href=\"mailto:gurkenheinz@gmx.de\">"
echo "    <font color=\"#0000FF\">ren22</font></a><br>"
echo "    version 0.1 <a href=\"http://napcom.de/fli4l.html\" target=\"_blank\">"
echo "    <font color=\"#0000FF\">http://napcom.de/fli4l.html</font></a></p>"
echo "</body></html>"

exit 0
